module QandA
  module Question
    class Boolean < Question
      TRUES  = ['yes', 'y', 'true', 't']
      FALSES = ['no', 'n', 'false', 'f']

      def initialize(message = '', default = nil)
        message = "#{message} (y/n)"
        super(message: message, default: default)
        @validation = Proc.new do |answer|
          answer = answer.downcase.strip
          TRUES.include?(answer) || FALSES.include?(answer)
        end
      end

      def ask
        super
        @answer = answer.downcase.strip
        @answer = true if TRUES.include?(@answer)
        @answer = false if FALSES.include?(@answer)
      end
    end
  end
end
