module QandA
  module Question
    class Question
      def initialize(message: '', default: nil, &validation)
        @msg        = message
        @default    = default
        @validation ||= validation ? validation : nil
        @answer     = nil
      end

      def ask(&block)
        yield if block_given?
        str = "#{@msg}"
        str << " [#{@default}]" if @default
        str << ': '
        while @answer == nil do
          print str
          a       = $stdin.gets.chomp
          a       = @default if @default && a.empty?
          @answer = a unless @validation
          @answer = a if @validation && instance_exec(a, &@validation)
          puts "Invalid answer, try again" unless @answer
        end
      end

      def answer
        @answer
      end
    end
  end
end
