module QandA
  class Questionnaire
    attr_reader :questions

    TYPE_REGISTER = {
        text:            QandA::Question::Text,
        multiple_choice: QandA::Question::MultipleChoice,
        boolean:         QandA::Question::Boolean,

    }

    def initialize
      @questions = {}
    end

    def add_question(key, type, *args)
      type = type.to_sym
      unless TYPE_REGISTER.has_key?(type)
        raise NoSuchQuestionTypeError.new("No such question type '#{type}'")
      end
      @questions[key] = TYPE_REGISTER[type].new(*args)
    end


    def run
      @questions.each do |key, q|
        q.ask
      end
    end

    def answers
      Hash[@questions.map { |key, q| [key, q.answer] }]
    end

  end
end